#!/bin/sh
#
# License: Copyright 2007 SpinetiX S.A. This file is licensed
#          under the terms of the GNU General Public License version 2.
#          This program is licensed "as is" without any warranty of any
#          kind, whether express or implied.
#
# Copyright 1999-2003 MontaVista Software, Inc.
# Copyright 2002, 2003, 2004 Sony Corporation
# Copyright 2002, 2003, 2004 Matsushita Electric Industrial Co., Ltd.
#
### BEGIN INIT INFO
# Required-Start:
# Required-Stop:
# Should-Start:
# Should-Stop:
# Default-Start: 2 3 5
# Default-Stop:
# Short-Description: Starting/stopping SpinetiX's Bonsai watchdog
# Description: Starting/stopping SpinetiX's Bonsai watchdog
### END INIT INFO
# chkconfig: 235 95 5
#

# Init script information
INIT_NAME=raperca-watchdog
DESC="Bonsai watchdog"

# watchdog daemon
DAEMON1=/usr/sbin/watchdog
ARGS1="-c /etc/raperca/watchdog.conf"
BASENAME1=watchdog
PIDFILE1=/var/run/$BASENAME1.pid

# sync to be sure we push all data before exiting watchdog
DAEMON2=/bin/sync
ARGS2=
BASENAME2=sync

# The dummy PID file, used by repair binary
# The PID in this file is 1, which always exists
PIDDUMMY=/var/run/watchdog-dummy.pid

# Load init script configuration
[ -f /etc/default/$INIT_NAME ] && . /etc/default/$INIT_NAME

# Source the init script functions
. /etc/init.d/init-functions

# Verify daemons are installed
[ "$1" = "status" ] && NFOUND=4 || NFOUND=5
test -f $DAEMON1 || exit $NFOUND

start() {
	local RET ERROR=

	# Create the dummy PID file
	echo 1 > "$PIDDUMMY"

	log_status_msg "Starting $DESC: " -n
	log_status_msg "$BASENAME1" -n
	sleep 1 # give a bit of time for daemons to create their PID files
	start-stop-daemon --start --quiet --exec $DAEMON1 -- $ARGS1
	RET=$?
	if [ $RET -eq 0 ]; then
		log_success_msg "," -n
	else
		log_failure_msg " failed ($RET: $ERROR), " -n
		return 1
	fi
	
	log_status_msg "boot-id" -n
	cat /proc/sys/kernel/random/boot_id > /var/cache/raperca/www/docs/boot-id
	log_status_msg "."

	# repeat above for each daemon...
	
	log_status_msg ""
	return 0
}

stop () {
	local RET ERROR=

	log_status_msg "Stopping $DESC: " -n
	log_status_msg "$BASENAME2" -n
	$DAEMON2
	RET=$?
	if [ $RET -eq 0 ]; then
	    log_status_msg ", " -n
	else
	    log_failure_msg "failed ($RET: $ERROR), " -n
	fi
	log_status_msg "$BASENAME1" -n
	start-stop-daemon --stop --quiet --pidfile $PIDFILE1
	RET=$?
	if [ $RET -eq 0 ]; then
		log_success_msg ". The device will hard reboot if no watchdog daemon is restarted within 1 min."
	else
		log_failure_msg "failed ($RET: $ERROR). " -n
		return 1
	fi

	# repeat above for each daemon...

	log_status_msg ""
	return 0
}

restart() {
	local RET

	log_status_msg "Restarting $DESC..."
	stop
	sleep 5
	start
	RET=$?

	return $RET
}

tryrestart() {
	local RET

	pidstatus $BASENAME1
	RET=$?
	if [ $RET -eq 0 ]; then
		restart
		RET=$?
	else
		RET=7
	fi

	return $RET
}

#
# if the service does not support reload return code 3 should
# be the result...
#
reload() {
	local RET

	log_status_msg "Reloading $DESC configuration..." -n
	# killproc $BASENAME1 -HUP
	#
	# repeat as necessary...
	#
	log_success_msg "done."

	# No support for reload
	return 3
}

forcereload() {
	local RET

	reload
	RET=$?
	if [ $RET -ne 0 ]; then
		restart
		RET=$?
	fi
	
	return $RET
}

status() {
	local RET
	
	printstatus $BASENAME1
	RET=$?

	return $RET
}

#
# Everything after this should be the same for all init scripts
#
# See the policy manual for information on actions and return codes.
#

parse() {
	case "$1" in
  start)
			start
			return $?
	;;
  stop)
			stop
			return $?
	;;
		restart)
			restart
			return $?
			;;
		try-restart)
			tryrestart
			return $?
			;;
		reload)
			reload
			return $?
			;;
		force-reload)
			forcereload
			return $?
			;;
		status)
			status
			return $?
	;;
  *)
			echo "Usage: $INIT_NAME " \
			"{start|stop|restart|try-restart|reload|" \
			"force-reload|status}" >&2
	;;
	esac
	
	return 1
}

parse $@

